% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [ handover,failure,unnecessary ] = HNE( beta,Et,R,sigma,tau_i,tau_o,P_f,v,d )

        RSS=10*log10(Et)-10*beta*log10(R); 
        l_OM = sqrt(R^2-(d/2).^2);
        noise = getnoise(sigma);
        RSS_est =RSS+noise;
        R_est= 10^((10*log10(Et)-RSS_est)/10/beta);
        %Calculate the number of handover failures and unnecessary
        %handovers of HNE
        if l_OM<=R_est %If not, no handover happens
           d_est=2*sqrt(R_est.^2-l_OM^2);
           l_OM_est = sqrt(R_est.^2-(d_est/2).^2);
           D1=2*R*sin(asin(v*tau_i/2/R)-pi/2*P_f); %Distance threshold for minimising handover failures
           %D2=2*R*sin(asin(v*(tau_i+tau_o)/2/R)-pi/2*P_u); %Distance threshold for minimising unnecessary handovers
           if d>=D1
              handover=1;
              if d_est<v*tau_i
                 failure=1; %Handover failure happens 
                 unnecessary=1;
              elseif d_est<v*(tau_i+tau_o)
                  failure=0;
                  unnecessary=1;
              else
                  failure=0;
                  unnecessary=0;
              end
           else
               handover=0;
               failure=0;
               unnecessary=0;
           end
%            if d_HNE(i,j)>=D2
%               totalnum_handover_HNE_pu(i)=totalnum_handover_HNE_pu(i)+1;
%               if d_HNE_est(i,j)<v(i)*(tau_i+tau_o)
%                  num_unnecessary_HNE(i)=num_unnecessary_HNE(i)+1; %Unnecessary handover happens
%               end
%            end
        else handover=0;failure=0;unnecessary=0;
        end
